Program Kolumz;
Uses TpCrt, TpWindow;

type
  Map    = Array [0..30,0..7] of Byte;
  Line   = Array [0..2] of Byte;
  OfsMap = Array [0..1,0..3] of ShortInt;

const
  MaxY    : Byte = 18;
  MaxCol  : Byte = 6;
  OfsMapX : Ofsmap = ((1,1,0,1),(2,2,0,2));
  OfsMapY : Ofsmap = ((0,1,1,-1),(0,2,2,-2));
  ZLn     : Line = (0,0,0);
  Atr     : Array [0..8] of byte = (0,9,10,11,12,13,14,15,7);

var
  SysTime                 : LongInt absolute $0:$046C;
  OldTime,NewTime         : LongInt;
  WorkTime                : word;
  ScoreWindow, GameWindow : WindowPtr;
  GameCount,GX,GY,OldX,OldY : Byte;
  RealSpeed,Speed,GameScore         : Word;
  BeepFlag,FoundLn,Flag   : Boolean;
  GameMap,Map1            : Map;
  GmLn                    : Line;
  GmStr                   : String;
  Key                     : Char;
  I,J                     : Byte;

Procedure Beep;
begin
  Sound(300);
  delay(25);
  NoSound;
end;

Procedure FoundLines(x,y:byte;l:map);
var
  mask,a,c,d,e,f,g,h	:	shortint;

begin
  mask:=L[y,x];
  if mask=0 then exit;
  for a:=0 to 3 do
    begin
      e:=y+OfsMapY[0,a];
      f:=x+OfsMapX[0,a];
      g:=y+OfsMapY[1,a];
      h:=x+OfsMapX[1,a];
      c:=L[e,f];
      d:=L[g,h];
      if ((c=mask) and (d=mask)) then
        begin
          Map1[y,x]:=1;
          Map1[e,f]:=1;
          Map1[g,h]:=1;
          inc(GameScore);
          inc(GameCount);
          BeepFlag:=True;
        end;
    end;
end;

Procedure ScrolLine;
var
  a,b,c : Byte;
begin
  a:=GmLn[0];
  b:=GmLn[1];
  c:=GmLn[2];
  GmLn[0]:=b;
  GmLn[1]:=c;
  GmLn[2]:=a;
end;

Procedure PutMap;
var
  a,b,c,d : Byte;
  begin
    for a:=1 to MaxY do
      begin
        gotoxy(3,a+1);
        for b:=0 to 5 do
          begin
            d:=a;
            c:=GameMap[d,b];
            FastWriteWindow('',a+1,(b shl 1)+3,atr[c]);
          end;
      end;
  end;

Procedure LnDown;
var
  x1,y1,z1 : Byte;
begin
  flag:=true;
  while flag do
    begin
      Flag:=false;
      For y1:=MaxY downto 1 do
        begin
          for x1:=0 to 5 do
              if ((GameMap[y1,x1]=0) and (GameMap[y1-1,x1]>0)) then
              begin
                   Flag:=true;
                   for z1:=y1-1 downto 1 do
                       GameMap[z1+1,x1]:=GameMap[z1,x1];
              end;
          if flag then y1:=1;
        end;
      Delay(100);
      PutMap;
  end;
end;

Procedure DelLines;
var
  x1,y1 : Byte;
  begin
       BeepFlag:=False;
       repeat
             FillChar(Map1,200,#0);
             FoundLn:=false;
             for y1:=MaxY downto 1 do
                 for x1:=0 to 5 do FoundLines(X1,Y1,GameMap);
             for y1:=MaxY downto 1 do
                 for x1:=0 to 5 do
                     if Map1[y1,x1]=1 then
                     begin
                          GameMap[y1,x1]:=0;
                          FoundLn:=true;
                     end;
             LnDown;
             PutMap;
       until not FoundLn;
       if BeepFlag then Beep;
       str(GameScore:5,GmStr);          {PrintScore}
       FastWrite(GmStr,24,60,7);
  end;

Procedure PutCol(L:Line;x,y:byte);
var i:byte;
  begin
    for I:=0 to 2 do
      begin
        FastWriteWindow('',Y-I,(X shl 1)+3,atr[L[I]]);
      end;
  end;

Procedure PutLine;
  begin
    PutCol(ZLn,OldX,OldY);
    PutCol(GmLn,GX,GY);
  end;


 begin
   Randomize;
   ClrScr;
   if Not MakeWindow(ScoreWindow,30,1,45,5,True,True,True,
                     112,112,112,' SCORE ') then Halt(2);
   if Not MakeWindow(GameWindow,10,1,27,22,True,True,True,
                     112,30,$1c,' KOLUMZ ') then Halt(2);
   if Not DisplayWindow(ScoreWindow) then Halt(2);
   if Not DisplayWindow(GameWindow) then Halt(2);
   GameScore:=0;
   FillChar(GameMap,200,#0);
   PutMap;
   Speed:=12;
   GameCount:=0;
   while GameMap[3,3]=0 do begin
   GX:=3;GY:=4;
   asm
      mov ah,0Ch
      int 21h
   end;
   OldX:=3;OldY:=5;
   for I:=0 to 2 do GmLn[I]:=Random(MaxCol)+1;          {RandLine}
   PutLine;
   RealSpeed:=Speed;
   repeat
     OldTime:=SysTime;
       repeat
         if keypressed then
           begin
             Key:=ReadKey;
             if Key=#0 then
               begin
                 Key:=ReadKey;
                 case Key of
                      #75: begin
                             OldX:=GX;
                             OldY:=GY;
                             if GX>0 then Dec(GX);
                             if GameMap[GY,GX]>0 then GX:=OldX;
                             PutLine;
                           end;
                      #77: begin
                             OldX:=GX;
                             OldY:=GY;
                             if Gx<5 then Inc(GX);
                             if GameMap[GY,GX]>0 then GX:=OldX;
                             PutLine;
                           end;
                      #72: begin
                             ScrolLine;
                             PutLine;
                           end;
                      #80: RealSpeed:=RealSpeed div 10;
                      end;
                 end;
             if key=#27 then Halt(2);
           end;
         NewTime:=SysTime;
         WorkTime:=NewTime-OldTime;
       until worktime>=RealSpeed;
       OldY:=GY;
       OldX:=GX;
       Inc(GY);
       PutLine;
{       delay(RealSpeed);}
   until ((GY>MaxY) or (GameMap[GY,GX]>0));
   for i:=0 to 2 do
     GameMap[GY-I-1,GX]:=GmLn[I];
   DelLines;
   if GameCount=19 then
     begin
       GameCount:=0;
       Speed:=(Speed div 3) shl 1;
     end;
 end;
   Beep;
   Key:=ReadKey;
end.